VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Associate This Program With .test Files"
   ClientHeight    =   3195
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   4680
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin MSComDlg.CommonDialog ComDia 
      Left            =   0
      Top             =   2640
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CheckBox chkAssoc 
      Caption         =   "Associate .test files with this program"
      Height          =   255
      Left            =   840
      TabIndex        =   1
      Top             =   2640
      Width           =   3255
   End
   Begin VB.TextBox Text1 
      Height          =   2295
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   120
      Width           =   4335
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Save"
      End
      Begin VB.Menu mnuSaveAs 
         Caption         =   "Save &As"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim fileOpen As String
Dim OrigAssoc As Boolean 'keep chkAssoc_Click code from executing until user interfaces with it
Dim exe_File_Path As String
Private Sub chkAssoc_Click()
    If chkAssoc.Value = vbChecked And OrigAssoc Then
        Call AssociateFileExtension("test", exe_File_Path, "TestFile")
    ElseIf OrigAssoc Then
        Call UnAssociateFileExtension("test", "TestFile")
    End If
End Sub

Private Sub Form_Load()
    Dim fnum As Integer, s As String, Ret
    Text1.Text = "Do not click checkbox below when running in IDE." & vbCrLf _
    & "Save it as an exe and run the exe." & vbCrLf _
    & "After the checkbox is checked," & vbCrLf _
    & "look in the application folder and" & vbCrLf _
    & "double click the Test Document.test"
    'see if .test file opened by double clicking
    If Command$ <> "" Then
        fnum = FreeFile
        Open Command$ For Input As fnum
        Text1.Text = Input$(LOF(fnum), #fnum)
        Close fnum
    End If
    'find out if program associated with .test files
    lpSubKey = "TestFile\shell\open\command"
    RC = RegOpenKey(HKEY_CLASSES_ROOT, lpSubKey, phkResult)
    lpData = Space(255)
    lpcbData = Len(lpData)
    RC = RegQueryValueEx(phkResult, "", 0&, REG_SZ, lpData, lpcbData)
    s = Left(lpData, lpcbData - 1)
    RC = RegCloseKey(phkResult)
    'define full path to .exe file
    exe_File_Path = App.Path
        If Right$(exe_File_Path, 1) <> "\" Then exe_File_Path = exe_File_Path & "\"
    exe_File_Path = exe_File_Path & App.EXEName
        If LCase$(Right$(exe_File_Path, 4)) <> ".exe" Then exe_File_Path = exe_File_Path & ".exe"
    'see if associated
    Ret = InStr(1, s, exe_File_Path)
    'if associated, put check in chkAssoc
    If Ret <> 0 Then
        chkAssoc.Value = vbChecked
    End If
    'keep chkAssoc_Click code from executing until user interfaces with it
        OrigAssoc = True
    
End Sub

Private Sub mnuOpen_Click()
    Dim fnum As Integer
    On Error GoTo ex
    ComDia.CancelError = True
    ComDia.FileName = ""
    ComDia.InitDir = App.Path
    ComDia.Flags = cdlOFNFileMustExist
    ComDia.Filter = "Test Files (*.test)|*.test"
    ComDia.Flags = &H4 'cdlOFNHideReadOnly &H4 Hides the Read Only
    ComDia.ShowOpen
    fileOpen = ComDia.FileName
    fnum = FreeFile
    Open fileOpen For Input As fnum
    Text1.Text = Input$(LOF(fnum), #fnum)
    Close fnum
    Exit Sub
ex:     If Err.Number = 32755 Then Exit Sub 'user pressed cancel
    MsgBox "Error # " & Err.Number & " - " & Err.Description
End Sub

Private Sub mnuSave_Click()
    Dim fnum As Integer
    If fileOpen = "" Then
        mnuSaveAs_Click
    Else
        fnum = FreeFile
        Open fileOpen For Output As fnum
        ' Write the file's contents (without an
        ' extra trailing vbCrLf).
        Print #fnum, Text1.Text;
        Close fnum
    End If
End Sub

Private Sub mnuSaveAs_Click()
    Dim fnum As Integer
    On Error GoTo ex
    ComDia.CancelError = True
    ComDia.FileName = ""
    ComDia.InitDir = App.Path
    ComDia.Flags = cdlOFNFileMustExist
    ComDia.Filter = "Test Files (*.test)|*.test"
    ComDia.Flags = &H2 'cdlOFNOverwritePrompt &H2 Prompts for Overwrite
    ComDia.ShowSave
    fileOpen = ComDia.FileName
    fnum = FreeFile
    Open fileOpen For Output As fnum
    ' Write the file's contents (without an
    ' extra trailing vbCrLf).
    Print #fnum, Text1.Text;
    Close fnum
    Exit Sub
ex:     If Err.Number = 32755 Then Exit Sub 'user pressed cancel
    MsgBox "Error # " & Err.Number & " - " & Err.Description

End Sub
